<?php

$className = "rbs";
$paymentName = "RBS Payment";

include "standalone.php";

$objectTypesCollection = umiObjectTypesCollection::getInstance();
$objectsCollection = umiObjectsCollection::getInstance();
$fieldsCollection = umiFieldsCollection::getInstance();
$fieldTypesCollection = umiFieldTypesCollection::getInstance();

$testTypeId = $objectTypesCollection->getTypeIdByGUID("user-emarket-payment-" . $className);
if ($testTypeId) {
	die($paymentName . " уже был установлен!");
}

// получаем родительский тип
$parentTypeId = $objectTypesCollection->getTypeIdByGUID("emarket-payment");

// Тип для внутреннего объекта, связанного с публичным типом
$internalTypeId = $objectTypesCollection->getTypeIdByGUID("emarket-paymenttype");
$typeId = $objectTypesCollection->addType($parentTypeId, $paymentName);

// Создаем внутренний объект
$internalObjectId = $objectsCollection->addObject($paymentName, $internalTypeId);
$internalObject = $objectsCollection->getObject($internalObjectId);
$internalObject->setValue("class_name", $className); // имя класса для реализации

// связываем его с типом
$internalObject->setValue("payment_type_id", $typeId);
$internalObject->setValue("payment_type_guid", "user-emarket-payment-" . $className);
$internalObject->commit();

// Связываем внешний тип и внутренний объект
$type = $objectTypesCollection->getType($typeId);
$type->setGUID($internalObject->getValue("payment_type_guid"));
// Добавляем в тип данных группу полей Параметры
$groupId = $type->addFieldsGroup('settings', 'Параметры');
$group = $type->getFieldsGroup($groupId);

// В группу добавляем поля для настройки оплаты
// Поле Логин
$fieldTypeId = $fieldTypesCollection->getFieldTypeByDataType('string')->getId();
$fieldId = $fieldsCollection->addField('login', 'Логин', $fieldTypeId);
$group->attachField($fieldId);
$field = $fieldsCollection->getField($fieldId);
$field->setImportanceStatus(true);	// Важное
$field->setIsRequired(true);		// Обязательное
$field->setIsInFilter(false);		// Фильтруемое
$field->setIsInSearch(false);		// Индексируемое
// Поле Пароль
$fieldTypeId = $fieldTypesCollection->getFieldTypeByDataType('password')->getId();
$fieldId = $fieldsCollection->addField('password', 'Пароль', $fieldTypeId);
$group->attachField($fieldId);
$field = $fieldsCollection->getField($fieldId);
$field->setImportanceStatus(true);	// Важное
$field->setIsRequired(true);		// Обязательное
$field->setIsInFilter(false);		// Фильтруемое
$field->setIsInSearch(false);		// Индексируемое
// Поле кнопка-флажок Двух-стадийность платежа
$fieldTypeId = $fieldTypesCollection->getFieldTypeByDataType('boolean')->getId();
$fieldId = $fieldsCollection->addField('stage', 'Двух-стадийность платежа', $fieldTypeId);
$group->attachField($fieldId);
$field = $fieldsCollection->getField($fieldId);
$field->setIsInFilter(false);		// Фильтруемое
$field->setIsInSearch(false);		// Индексируемое
// Поле кнопка-флажок Тестовый режим
$fieldTypeId = $fieldTypesCollection->getFieldTypeByDataType('boolean')->getId();
$fieldId = $fieldsCollection->addField('test_mode', 'Тестовый режим', $fieldTypeId);
$group->attachField($fieldId);
$field = $fieldsCollection->getField($fieldId);
$field->setIsInFilter(false);		// Фильтруемое
$field->setIsInSearch(false);		// Индексируемое
// Поле кнопка-флажок Передавать данные для печати чека
$fieldTypeId = $fieldTypesCollection->getFieldTypeByDataType('boolean')->getId();
$fieldId = $fieldsCollection->addField('send_order', 'Передавать данные для печати чека', $fieldTypeId);
$group->attachField($fieldId);
$field = $fieldsCollection->getField($fieldId);
$field->setIsInFilter(false);		// Фильтруемое
$field->setIsInSearch(false);		// Индексируемое
// Поле кнопка-флажок Вести журнал (журнал ведется в файл rbs_payment.log в корне сайта)
$fieldTypeId = $fieldTypesCollection->getFieldTypeByDataType('boolean')->getId();
$fieldId = $fieldsCollection->addField('logging', 'Вести журнал', $fieldTypeId);
$group->attachField($fieldId);
$field = $fieldsCollection->getField($fieldId);
$field->setIsInFilter(false);		// Фильтруемое
$field->setIsInSearch(false);		// Индексируемое

$group->commit();
$type->commit();

echo $paymentName . " успешно установлен!";